<urbo-cms-ui-table
  [data]="roles"
  [columns]="cols"
  [rows]="rows"
  [totalRecords]="totalRecords"
  [paginator]="true"
  [lazy]="false"
  [rowsPerPageOptions]="[10, 25, 50]"
  (createButtonClick)="navigateToCreateRole()"
  (edit)="editRole($event)"
  (delete)="deleteRole($event)"
  [createPermission]="Permission.Administration"
  [editPermission]="Permission.Administration"
  [deletePermission]="Permission.Administration"
></urbo-cms-ui-table>

<p-dialog
  [(visible)]="roleDialog"
  [modal]="true"
  header="Rolle Details"
  [style]="{ width: '450px' }"
  (onHide)="hideDialog()"
  class="p-fluid"
>
  <div *ngIf="selectedRole">
    <div class="field">
      <label for="name">Rollenname</label>
      <input type="text" id="name" [(ngModel)]="selectedRole.name" pInputText />
    </div>
    <div class="field">
      <label for="permissions">Berechtigungen</label>
      <p-multiSelect
        id="permissions"
        [(ngModel)]="selectedRole.permissions"
        [options]="permissions"
        optionLabel="label"
        optionValue="value"
        placeholder="Wähle Berechtigungen"
        appendTo="body"
      >
      </p-multiSelect>
    </div>
  </div>
  <ng-template pTemplate="footer">
    <button
      pButton
      pRipple
      label="Abbrechen"
      icon="pi pi-times"
      class="p-button-text"
      (click)="hideDialog()"
    ></button>
    <button
      pButton
      pRipple
      label="Speichern"
      icon="pi pi-check"
      class="p-button-text"
      (click)="saveRole()"
    ></button>
  </ng-template>
</p-dialog>

<p-dialog
  [(visible)]="deleteRoleDialog"
  header="Bestätigen"
  [modal]="true"
  [style]="{ width: '450px' }"
>
  <div class="flex align-items-center justify-content-center">
    <i class="pi pi-exclamation-triangle mr-3" style="font-size: 2rem"></i>
    <span>Bist du sicher, dass du diese Rolle löschen möchtest?</span>
  </div>
  <ng-template pTemplate="footer">
    <button
      pButton
      pRipple
      icon="pi pi-times"
      class="p-button-text"
      label="Nein"
      (click)="deleteRoleDialog = false"
    ></button>
    <button
      pButton
      pRipple
      icon="pi pi-check"
      class="p-button-text"
      label="Ja"
      (click)="confirmDelete()"
    ></button>
  </ng-template>
</p-dialog>
